Intro
=====

This document is designed to provide a list of the minimum levels of
software necessary to run the 2.2 kernels, as well as provide brief
instructions regarding any other "Gotchas" users may encounter when
trying life on the Bleeding Edge.  If upgrading from a pre-2.0.x
kernel, please consult the Changes file included with 2.0.x kernels for
additional information; most of that information will not be repeated
here.  Basically, this document assumes that your system is already
functional and running at least 2.0.x kernels.

   It is originally based on my "Changes" file for 2.0.x kernels and
therefore owes credit to the same people as that file (Jared Mauch, Axel
Boldt, Alessandro Sigala, and countless other users all over the 'net).
Please feel free to submit changes, corrections, gripes, flames, money,
etc. to me (chris.ricker@genetics.utah.edu).  If you do so, you don't
need to bother doing so in the form of a diff, as this is generated by
texinfo so a diff is useless anyway (though I can incorporate one by
hand if you insist upon sending it that way ;-).

   The most current version should always be available from
http://cyberbuzz.gatech.edu/kaboom/linux/ as well.

   Voir
http://www.linux-france.com/article/sys/Changes-2.2/Changes-2.2.1.html
pour la traduction français.

   Nihongo-ban ha kochira desu (text & html)
http://www.linux.or.jp/JF/JFdocs/kernel-docs-2.2/Changes
http://www2.palnet.or.jp/~matsuda/Changes-2.2.ja.html

   Visite http://www2.adi.uam.es/~ender/tecnico/cambios22.html para
obtener la traducción al español de este documento.

   Also, don't forget

   http://www.linuxhq.com/

   http://www.kernelnotes.org/

   http://www.kernel.org/

   for all your Linux kernel needs.

Last updated: July 13, 1999
Current Author: Chris Ricker (kaboom@gatech.edu or
	chris.ricker@genetics.utah.edu).

Current Minimal Requirements
****************************

   Upgrade to at *least* these software revisions before thinking you've
encountered a bug!  If you're unsure what version you're currently
running, the suggested command should tell you.

- Kernel modutils	 2.1.121                 ; insmod -V
- Gnu C 		 2.7.2.3                 ; gcc --version
- Binutils		 2.8.1.0.23              ; ld -v
- Linux libc5 C Library	 5.4.46                  ; ls -l /lib/libc*
- Linux libc6 C Library  2.0.7pre6               ; ls -l /lib/libc*
- Dynamic Linker (ld.so) 1.9.9                   ; ldd --version or ldd -v
- Linux C++ Library	 2.7.2.8                 ; ls -l /usr/lib/libg++.so.*
- Procps		 1.2.9                   ; ps --version
- Procinfo               16                      ; procinfo -v
- Psmisc		 17			 ; pstree -V
- Net-tools              1.52                    ; hostname -V
- Loadlin                1.6a
- Sh-utils               1.16                    ; basename --v
- Autofs                 3.1.1                   ; automount --version
- NFS                    2.2beta40               ; showmount --version
- Bash                   1.14.7                  ; bash -version
- Ncpfs                  2.2.0                   ; ncpmount -v
- Pcmcia-cs              3.0.13                  ; cardmgr -V
- PPP                    2.3.8                   ; pppd --version
- Util-linux             2.9t                    ; chsh -v

Upgrade notes
*************

General Information
===================

   <CTRL><ALT><DEL> now performs a cold reboot instead of a warm reboot
for increased hardware compatibility.  If you want a warm reboot and
know it works on your hardware, add a "reboot=warm" command line option
in LILO.  A small number of machines need "reboot=bios" to reboot via
the BIOS.

   Also, please remember that cua* devices are now obsolete.  Switch to
the corresponding ttyS* device instead (e.g., cua0 -> ttyS0, cua1 ->
ttyS1, etc.).

   In addition, some software still works, but needs to be compiled
against 2.2 headers for complete functionality.  Fdutils binaries
compiled under 2.0 or earlier kernels should be replaced with ones
compiled under 2.2, for example.

   As of 2.1.115, support for the deprecated major 4 /dev/ttyp* devices
was removed.  If necessary (eg, you get "out of pty" error messages
when you obviously are not out of pty's), create major 3 /dev/tty* and
major 2 /dev/pty* devices (see Documentation/devices.txt for more
information).  In general, you should make sure that your /dev
directory is up-to-date if you are experiencing any problems.

   Optional support for Unix98 pty devices has also been added. If you
want to use the Unix98 ptys, you should be running at least
glibc-2.0.9x, and you must switch completely to Unix98 pty's.  The
general procedure for configuring Unix98 pty support is:

- Compile your kernel with CONFIG_UNIX98_PTYS and CONFIG_DEVPTS_FS.
- mknod /dev/ptmx c 5 2
  chmod 666 /dev/ptmx
  mkdir /dev/pts
- Add to /etc/fstab:

  none            /dev/pts        devpts	gid=5,mode=620    0 0

   (Note:  gid=5 is applicable for Red Hat systems for which group "tty" has
   gid 5.  Adjust according to your distribution.  Use mode=600 if you want
   "mesg n" to be default.)
- Mount /dev/pts

   Frame buffer consoles ("fbcon") are now in the kernel for all
platforms, not just those non-Intel ones for which VGA text mode is
impossible.  VGAcon is still available for those who want it, but fbcon
has the advantage of providing a uniform graphical subsystem across all
Linux ports, and it displays a spiffy penguin logo on boot-up ;-).  For
more information, see the files in Documentation/fb/ ; you may also
need to download the fbset utilities.

Libc (libc5)
============

   Linux-2.2 is ELF-only.  You can still compile a.out apps if you
really want, but your kernel must be compiled ELF.  If you can't
currently compile ELF, consult the ELF howto at
http://metalab.unc.edu/mdw/HOWTO/ELF-HOWTO.html and upgrade your system
accordingly.

   For modules to work, you need to be running libc-5.4.x or greater.
Since updates to libc fix other problems as well (security flaws, for
example) and since 5.4.7 is missing a few needed symbols, try to get
the latest 5.4.x you can.  Currently, libc-5.4.46 is the latest public
release.

   If you upgrade to libc-5.4.x, you also have to upgrade your dynamic
linker (ld.so) to at least 1.9.9, or all sorts of weirdness will happen.
Actually, ld.so-1.8.2 and later will work, but 1.9.9 is widely
available, so if you need to upgrade, use it.  If you get a release
later than 1.8.5, avoid 1.8.10 as it introduces a few bugs that are
fixed in later releases.  Please make sure you don't install ld.so-2.x
unless you're running glibc2 / libc6.

   If you upgrade to libc-5.4.x, you may also need to upgrade ypbind if
you're using NIS.  For ypbind and glibc, you'll probably need the
ypbind-3.3-glibc5.diff patch available in the same place as the ypbind
source.

   If you upgrade to libc-5.4.46, please read and pay attention to its
accompanying release notes.  The section about it breaking make is not a
joke.

GNU libc (libc6)
================

   Older versions of GNU libc (libc6) have a bug in the dynamic linker.
/etc/ld.so.cache gets mapped into memory and is never unmapped.  If one
of your boot scripts calls ldconfig, /etc/ld.so.cache is deleted.  Init,
however, still references that file; as of 2.1.122, the kernel will
consequently not be able to remount the root file system r/o at system
shutdown.  To fix this, upgrade to at least the pre6 release of GNU libc
2.0.7.  As a temporary workaround, modify your boot scripts to do the
following before calling ldconfig:

   	ln -f /etc/ld.so.cache /etc/ld.so.cache.old

Modules
=======

   You need to upgrade to the latest version of modutils for the Linux
2.2 kernel.  This version will also work with your 2.0 kernel.

   As of 2.1.90-pre1, kerneld has been replaced by a kernel thread,
kmod.  See Documentation/kmod.txt for more information.  The main
user-level change this requires is modification to your init scripts to
check for the absence of /proc/sys/kernel/modprobe before starting
kerneld.

Binutils
========

   If you upgrade binutils, please read its accompanying release notes
to find out the proper way to upgrade it.  No, the instruction to "rm
`which encaps`" is not a joke.

   The last public release of the binutils 2.8.x series was 2.8.1.0.23.
Binutils 2.8.1.0.25 to 2.9.1.0.2 are beta releases, and are known to be
very buggy.  Binutils 2.9.1 (note the absence of a suffix) from the FSF
should work, and binutils 2.9.1.0.7 and later releases are also good.
Either use binutils-2.8.1.0.23 or binutils-2.9.1.0.7 or later.  Glibc2
users should especially try to use the 2.9.1.0.x releases, as they
resolve known issues with glibc2 and binutils-2.8.x releases.

   libbfd, libiberty, and /usr/include/bfd.h, which are part of recent
binutils packages, are also required to compile ksymoops.  Depending
upon your distribution, this may require you to install both binutils
and binutils-development packages (Debian puts bfd.h in binutils-dev,
for example).

Bin86
=====

   To compile the kernel on the IA32 platform, a real-mode assembler and
linker is required.  These are found in the bin86 package.

Gnu C
=====

   You need at least GCC 2.7.2 to compile the kernel.  If you're
upgrading from an earlier release, you might as well get GCC 2.7.2.3,
the latest stable public release.  If you already have GCC 2.7.2 on
your system, you don't have to upgrade just so the kernel will work
(though feel free to upgrade if you want the gcc bug fixes).

   Note that the latest compilers (egcs, pgcc, gcc 2.8) may do Bad
Things while compiling your kernel, particularly if absurd
optimizations (like -O9) are used.  Caveat emptor.  Currently, the only
C compiler available in a binary distribution is egcs.  Version 1.0.3
seems okay; if you have to have a binary, you may be successful using
that.  In general, however, gcc-2.7.2.3 is known to be stable, while
egcs and others have not been as thoroughly tested yet.

Networking Changes
==================

   Please read Documentation/networking/routing.txt and
Documentation/networking/policy-routing.txt for more information about
changes in routing code.  OSPF classes have been added, and interface
routes are generated automatically.

   If for some reason you need to override this automatic default
routing, you have to specify the complete route specification (netmask,
device, etc.) for the kernel to accept it. Consequently, you need to
either remove interface routes from your init scripts or add missing
information to them if you need to replace the automatic routes.

   Also note that some routes, such as loopback routes, do not show up
in some standard tools.  Check in /proc/net/rt_local to verify their
presence.

   To turn on IP forwarding, issue the following command:   echo 1 >
/proc/sys/net/ipv4/ip_forward

   Similar procedures are necessary to turn on other features.  If
something appears broken, check the /proc/sys/net/ipv4/ directory.  "1"
generally denotes enabled, while "0" generally denotes disabled.

   If you're experiencing reports of lots of network errors, chances
are you need to upgrade to a more recent net-tools that understands the
new /proc/net/dev format.  This will also provide support for new
features like IPv6.

   As of 2.1.102, the IP firewalling code has been replaced; ipfwadm
will no longer work.  You need to obtain "ipchains," available from
http://www.rustcorp.com/linux/ipchains/ , and use that instead of
ipfwadm.

   To use masq forwarding you will need to obtain "ipmasqadm,"
available from http://juanjox.linuxhq.com/ .

   DHCP clients for 2.0 do not work with the new networking code in the
2.2 kernel.  You will need to upgrade your dhcpcd / dhcpclient.

   The ISDN code in the stock 2.2 kernel may not work for you.  If it
doesn't, look in ftp://ftp.suse.com/pub/isdn4linux for updated versions.

   In 2.0.x the kernel could be configured to drop source routed IP
packets via a compile time configuration option.  In 2.2.x, this has
been replaced by a sysctl.  See Documentation/networking/ip-sysctl.txt
for more information.

Memory
======

   As of 2.1.41, the format of /proc/meminfo has changed.  This broke
many memory utils, which have to be upgraded.  Get the new procps-1.2
and you should be set.

Network File System
===================

   The NFS code in the kernel is currently being revised, resulting in
much-improved performance.  Also, amd is being phased out in favor of
the much better autofs.  You'll also have to get the appropriate utils
to use autofs as well as the new NFS utils.  In addition, you have the
choice of user-land NFS or kernel-level NFS (knfs).

Util-linux (including mount)
============================

   Among other changes made in the development of Linux kernel 2.2, the
128 meg limit on IA32 swap partition sizes has been eliminated.  To use
larger swap spaces, you need the new mkswap found in util-linux.  You
also need to upgrade util-linux to get the latest version of mount.

   Partitions on 2048-bytes-per-sector media (certain magneto-opticals
most prominently) were broken throughout the 2.1 kernel series, meaning
that you will be unable to use 2.1-partitioned media on Linux 2.2. This
is not a 2.2 bug - 2.2 finally does the right thing!  [If you have to
interchange media between Linux 2.1 and 2.2, your best bet is to not
use partitions at all but create the filesystem on the raw device (e.g.
/dev/sda) instead.  This is also known as the superfloppy format.]

   To properly create partitions on 2048-bytes-per-sector media with
Linux 2.2, be sure to use no less than fdisk version 2.9i and invoke
fdisk using '-b 2048' as an option.

RPM
===

   If you run Red Hat Linux or any other distribution that uses RPM,
you need to upgrade RPM to a 2.5.x or later version.

DOSEMU
======

   A new "stable" version of DOSEMU is available for 2.2 kernels.
Upgrade to 0.98.6 or later.

Loadlin
=======

   Linux 2.1.22 and later releases use a new method of memory size
detection, requiring loadlin users to upgrade to loadlin-1.6a.

Sh-utils
========

   As of Linux-2.1.26, the Configure script ("make config") has been
updated to be POSIX-compliant.  As a result, your expr needs to be
updated.  Use sh-utils 1.16 or later.

Parallel Ports
==============

   As of 2.1.33, parallel port support can now be handled by the parport
driver.  Be aware that with Plug-and-Play support turned on, your
parallel port may no longer be where you expect it; for example, LPT1
(under DOS) was sometimes /dev/lp1 in Linux, but will probably be
/dev/lp0 with the new Plug-and-Play driver.  If printing breaks with
the new driver, try checking your lpd configuration.  A good source of
more information is the Documentation/parport.txt file included with
the kernel.

Setserial
=========

   If you experience random problems (stuck lines, lost characters,
etc.) with serial lines under recent kernels, upgrading setserial
should help.

Syncookies
==========

   When you build your kernel with Syncookie support
(CONFIG_SYN_COOKIES) the syncookie code still defaults to off (unlike
the 2.0.30+ behavior).  You have to explicitly enable it by issuing the
following command:

   echo 1 > /proc/sys/net/ipv4/tcp_syncookies

Bash
====

   Old versions of Bash fail to properly handle symlinks, which can
cause problems when compiling modules.  Upgrade to at least 1.14 to fix
this problem.

Sysklogd
========

   Older versions of sysklogd sometimes segfault under 2.2 kernels.
Upgrading to the latest release fixes that problem as well as adding
support for new features like system power-off on halt (with
appropriate incantations of halt; see the man page) and automatic
decoding of kernel oopses.

Ncpfs
=====

   To mount NetWare shares, you'll need to upgrade to a more recent
version of the ncpfs utils.

SMBfs
=====

   To mount SMB (Samba / Windows) shares, you'll need to use the
smbmount utility included with release 2.0 of Samba.
Documentation/filesystems/smbfs.txt has more information about this.
Note that smbmount must have been built against 2.2 headers to work with
2.2; if all else fails, recompile it and hope it works ;-).  In
addition, Mike Warfield has a script and some information at
http://www.wittsend.com/mhw/smbmount.html that you will probably find
useful.

Pcmcia-cs
=========

   If you use pcmcia cards, you'll need to upgrade the daemon and
support utils to the latest release of pcmcia-cs.

PPP
===

   Due to changes in the routing code, those of you using PPP
networking will need to upgrade your pppd.

iBCS
====

   A new version of iBCS is necessary for 2.2 kernels.

AppleTalk
=========

   Use the Asun version of netatalk for AppleTalk support, as Umich's
version is not compatible with 2.2 kernels.

Psmisc
======

   fuser, which comes with psmisc, reads /proc/*/fd/* to do its job.
Upgrade psmisc if 2.2 changes to /proc broke the version you're using.

Tunelp
======

   A new version of tunelp is available which will allow you to enable
"trustirq" mode, improving printing while using IRQ-driven lp ports.

PCI utils
=========

   Linux PCI utils are available; these include lspci, which displays
the detailed information about your system's PCI devices which used to
be in /proc/pci, and setpci, which allws you to read and write
configuration registers on your PCI devices.

Xosview
=======

   Changes to the /proc interface require a recent xosview.

RealPlayer
==========

   Current releases of Real Player 5.0 depend on a bug in the sound
sub-system which is no longer there.  Consequently, they don't work.
Real is aware of the problem and should have an updated version of the
software available shortly.  In the mean time, you can always try
backing up your copy of rvplayer, and then editing it by:

   dd if=/dev/zero of=rvplayer bs=1 count=1 seek=657586 conv=notrunc

   dd if=/dev/zero of=rvplayer bs=1 count=1 seek=665986 conv=notrunc

   If you're lucky, you'll then have sound....

   You may also need to edit it with

   dd if=/dev/zero of=rvplayer bs=1 count=1 seek=702554 conv=notrunc

   as well.  Alternately, download rpopen from
http://onramp.i2k.com/~jeffd/rpopen/ and pre-load it before you run
rvplayer (it's a shared object which blocks rvplayer from doing the
NONBLOCKing open of /dev/dsp).

Quotas
======

   If you are using large quotas, you should upgrade your quota utils;
newer versions count file sizes in blocks instead of bytes, providing
an upper limit of terabytes instead of 4 GB.

Ping
====

   Most distributed ping clients are buggy.  Get an updated one from the
iputils package.

Patch
=====

   Really old versions of patch cannot delete files.  This can be a
problem if you try to upgrade via patches.  If, for example, you are
unable to compile Linux 2.2, you may have an outdated version of patch.
Upgrade, re-patch the kernel, and try again.

Process accounting
==================

   If you use process accounting, you need to recompile the package
against 2.2 kernel includes for it to work properly.  Furthermore, when
you do so, watch out for a quirky configure script.  Your generated
config.h file needs to

   #define HAVE_LINUX_ACCT_H

   but instead it often has

   /* #undef HAVE_LINUX_ACCT_H */

   so be sure to check that when you recompile.

Where to get the files
**********************

Binutils
========

The 2.8.1.0.23 release:
ftp://tsx-11.mit.edu/pub/linux/packages/GCC/binutils-2.8.1.0.23.bin.tar.gz
ftp://metalab.unc.edu/pub/Linux/GCC/binutils-2.8.1.0.23.bin.tar.gz
Installation notes:
ftp://tsx-11.mit.edu/pub/linux/packages/GCC/release.binutils-2.8.1.0.23
ftp://metalab.unc.edu/pub/Linux/GCC/release.binutils-2.8.1.0.23

The 2.9.1.0.15 release:
ftp://tsx-11.mit.edu/pub/linux/packages/GCC/binutils-2.9.1.0.15-glibc.x86.tar.gz
ftp://tsx-11.mit.edu/pub/linux/packages/GCC/binutils-2.9.1.0.15-libc5.x86.tar.gz
ftp://tsx-11.mit.edu/pub/linux/packages/GCC/binutils-2.9.1.0.15.tar.gz
ftp://metalab.unc.edu/pub/Linux/GCC/binutils-2.9.1.0.15-glibc.x86.tar.gz
ftp://metalab.unc.edu/pub/Linux/GCC/binutils-2.9.1.0.15-libc5.x86.tar.gz
ftp://metalab.unc.edu/pub/Linux/GCC/binutils-2.9.1.0.15.tar.gz
Installation notes:
ftp://tsx-11.mit.edu/pub/linux/packages/GCC/release.binutils-2.9.1.0.15
ftp://metalab.unc.edu/pub/Linux/GCC/release.binutils-2.9.1.0.15

Bin86
=====

The 0.4 release:
ftp://metalab.unc.edu/pub/Linux/GCC/bin86-0.4.tar.gz
ftp://tsx-11.mit.edu/pub/linux/packages/GCC/bin86-0.4.tar.gz

Gnu C
=====

The egcs-1.0.3 release:
ftp://tsx-11.mit.edu/pub/linux/packages/GCC/egcs-1.0.3-glibc.x86.tar.bz2
ftp://tsx-11.mit.edu/pub/linux/packages/GCC/egcs-1.0.3-libc5.x86.tar.bz2
ftp://metalab.unc.edu/pub/Linux/GCC/egcs-1.0.3-glibc.x86.tar.bz2
ftp://metalab.unc.edu/pub/Linux/GCC/egcs-1.0.3-libc5.x86.tar.bz2
Installation notes:
ftp://tsx-11.mit.edu/pub/linux/packages/GCC/release.egcs-1.0.3
ftp://metalab.unc.edu/pub/Linux/GCC/release.egcs-1.0.3

Gnu C 2.7.2.3 source:
ftp://ftp.gnu.org/gnu/gcc/gcc-2.7.2.3.tar.gz
ftp://metalab.unc.edu/pub/gnu/gcc-2.7.2.3.tar.gz

Linux C Library
===============

The (libc5) 5.4.46 release:
ftp://tsx-11.mit.edu/pub/linux/packages/GCC/libc-5.4.46.bin.tar.gz
ftp://metalab.unc.edu/pub/Linux/GCC/libc-5.4.46.bin.tar.gz
Installation notes for 5.4.46:
ftp://tsx-11.mit.edu/pub/linux/packages/GCC/release.libc-5.4.46
ftp://metalab.unc.edu/pub/Linux/GCC/release.libc-5.4.46

The (libc6) GNU libc 2.0.7pre6 release:
ftp://ftp.kernel.org/pub/software/libs/glibc/glibc-2.0.7pre6.tar.gz
ftp://ftp.kernel.org/pub/software/libs/glibc/glibc-2.0.7pre6.tar.bz2

Linux C++ Library
=================

The 2.7.2 release:
ftp://ftp.gnu.org/gnu/libg++/libg++-2.7.2.tar.gz

Dynamic Linker
==============

The 1.9.9 release:
ftp://tsx-11.mit.edu/pub/linux/packages/GCC/ld.so-1.9.9.tar.gz
ftp://metalab.unc.edu/pub/Linux/GCC/ld.so-1.9.9.tar.gz

Modules utilities
=================

The 2.1.121 release:
ftp://ftp.kernel.org/pub/linux/kernel/v2.1/modutils-2.1.121.tar.gz

Procps utilities
================

The 1.2 release:
ftp://tsx-11.mit.edu/pub/linux/sources/usr.bin/procps-1.2.9.tar.gz
ftp://metalab.unc.edu/pub/Linux/system/status/ps/procps-1.2.9.tgz

Procinfo utilities
==================

The 16 release:
ftp://ftp.cistron.nl/pub/people/svm/procinfo-16.tar.gz

Psmisc utilities
================

The 17 release:
ftp://lrcftp.epfl.ch/pub/linux/local/psmisc/psmisc-17.tar.gz
ftp://metalab.unc.edu/pub/Linux/system/status/ps/psmisc-17.tar.gz

RPM utilities
=============

The 2.5.1 source release:
ftp://ftp.rpm.org/pub/rpm/dist/rpm-2.5.x/rpm-2.5.1-1.src.rpm
ftp://ftp.rpm.org/pub/rpm/dist/rpm-2.5.x/rpm-2.5.1.tar.gz

DOSEMU
======

The 0.98.6 release:
ftp://tsx-11.mit.edu/pub/linux/ALPHA/dosemu/dosemu-0.98.6.tgz
ftp://ftp.dosemu.org/dosemu/dosemu-0.98.6.tgz

Loadlin
=======

The 1.6a release:
ftp://ftp.suse.com/pub/loadlin/update-1.6a/loadlin.exe.gz
ftp://elserv.ffm.fgan.de/pub/linux/loadlin-1.6/update-1.6a/loadlin.exe.gz

Sh-utils
========

The 1.16 release:
ftp://metalab.unc.edu/pub/gnu/sh-utils-1.16.tar.gz
ftp://ftp.gnu.org/gnu/sh-utils/sh-utils-1.16.tar.gz

Util-linux
==========

The 2.9 release:
ftp://ftp.win.tue.nl/pub/linux/utils/util-linux/util-linux-2.9t.tar.gz

Autofs
======

The 3.1.3 release:
ftp://ftp.kernel.org/pub/linux/daemons/autofs/autofs-3.1.3.tar.gz

NFS
===

The user-land 2.2beta40 release:
ftp://ftp.mathematik.th-darmstadt.de/pub/linux/okir/dontuse/nfs-server-2.2beta40.tar.gz
ftp://linux.nrao.edu/mirrors/fb0429.mathematik.th-darmstadt.de/pub/linux/okir/dontuse/nfs-server-2.2beta40.tar.gz

The kernel-level 1.4.4 release:
ftp://ftp.varesearch.com/pub/support/hjl/knfsd/knfsd-1.4.4.tar.gz
ftp://ftp.kernel.org/pub/linux/devel/gcc/knfsd-1.4.4.tar.gz

Net-tools
=========

The 1.52 release:
ftp://ftp.cs-ipv6.lancs.ac.uk/pub/Code/Linux/Net_Tools/net-tools-1.52.tar.gz
http://www.tazenda.demon.co.uk/phil/net-tools/net-tools-1.52.tar.gz

Ypbind
======

The 3.3 release:
ftp://ftp.kernel.org/pub/linux/utils/net/NIS/ypbind-3.3.tar.gz

Sysklogd
========

The 1.3-31 release:
ftp://metalab.unc.edu/pub/Linux/system/daemons/sysklogd-1.3-31.tar.gz

Bash
====

The 1.14.7 release:
ftp://ftp.gnu.org/gnu/bash/bash-1.14.7.tar.gz

The 2.03 release:
ftp://ftp.gnu.org/gnu/bash/bash-2.03.tar.gz

Ncpfs
=====

The 2.2.0 release:
ftp://ftp.gwdg.de/pub/linux/misc/ncpfs/ncpfs-2.2.0.tgz

SMBfs
=====

The 2.0.5a release of Samba:
ftp://ftp.samba.org/pub/samba/samba-2.0.5a.tar.gz

Pcmcia-cs
=========

The 3.0.13 release:
ftp://hyper.stanford.edu/pub/pcmcia/pcmcia-cs.3.0.13.tar.gz

Setserial
=========

The 2.15 release:
ftp://tsx-11.mit.edu/pub/linux/sources/sbin/setserial-2.15.tar.gz
ftp://metalab.unc.edu/pub/Linux/system/serial/setserial-2.15.tar.gz

PPP
===

The 2.3.8 release:
ftp://cs.anu.edu.au/pub/software/ppp/ppp-2.3.8.tar.gz

IP Chains
=========

The 1.3.8 release:
ftp://ftp.rustcorp.com/ipchains/ipchains-1.3.8.tar.gz
ftp://ftp.rustcorp.com/ipchains/ipchains-1.3.8.tar.bz2

IP Masq Adm
===========

The 0.4.2 release:
http://juanjox.linuxhq.com/ipmasqadm-0.4.2.tar.gz

DHCP clients
============

The 2.0b1pl27 ISC dhcpclient release:
ftp://ftp.isc.org/isc/dhcp/test/dhcp-2.0b1pl27.tar.gz

The 1.3.17-pl2 PhysTech dhcpcd release:
ftp://ftp.phystech.com/pub/dhcpcd-1.3.17-pl2.tar.gz

iBCS
====

The 11/05/98 release:
ftp://tsx-11.mit.edu/pub/linux/BETA/ibcs2/ibcs-2.1-981105-ALPHA.tar.gz

Asun netatalk
=============

The 2.0a18.2 release:
ftp://ftp.u.washington.edu/pub/user-supported/asun/netatalk-1.4b2+asun2.0a18.2.tar.gz

Fbset
=====

The 2.1 release:
http://www.cs.kuleuven.ac.be/~geert/bin/fbset-2.1.tar.gz

PCI utils
=========

The 2.0 release:
ftp://atrey.karlin.mff.cuni.cz/pub/linux/pci/pciutils-2.0.tar.gz
ftp://metalab.unc.edu/pub/Linux/hardware/pciutils-2.0.tar.gz

Tunelp
======

The 0-2.1.131 release:
ftp://e-mind.com/pub/linux/tunelp/tunelp-0-2.1.131.tar.gz

Xosview
=======

The 1.6.1 release:
ftp://metalab.unc.edu/pub/Linux/system/status/xstatus/xosview-1.6.1.tar.gz

Quota utils
===========

The 1.55 release:
ftp://ftp.uk.linux.org/pub/linux/sct/quota/quota-1.55-10.i386.rpm
ftp://ftp.uk.linux.org/pub/linux/sct/quota/quota-1.55-10.src.rpm

IP utils
========

The June 1999 release:
ftp://ftp.inr.ac.ru/ip-routing/iproute2-2.2.4-now-ss990630.tar.gz
ftp://ftp.inr.ac.ru/ip-routing/iputils-ss990610.tar.gz

Patch
=====

The 2.5 release:
ftp://ftp.gnu.org/gnu/patch/patch-2.5.tar.gz

Other Info
==========

   Please remember that most of these utils are available on your
favorite local linux mirror.  If you can, please get them from a closer
site before checking metalab or tsx-11.

   You may also want to check for updated versions of this software in a
package format for the distribution you use.

   For those of you running Red Hat (or RPM on a different
distribution), most of these are available in RPM format.  Check around
your favorite Red Hat mirror site before installing the non-RPM
version.  Remember, you might need to use the --force option to get the
upgrade to install.  ftp://contrib.redhat.com/ ,
ftp://developer.redhat.com/ , or ftp://updates.redhat.com/ will have
almost everything you need, and Red Hat 5.2 ships with most necessary
software.

   Those of you running Debian (or a different distribution that
supports .deb packages) can look in the "unstable" and
"project/experimental" directories of your favorite Debian mirror.  The
Debian 2.0 release ships with most packages you need as well.

Please send info about any other packages that 2.2 "broke" or about any
new features of 2.2 that require extra or new packages for use to Chris
Ricker (kaboom@gatech.edu or chris.ricker@genetics.utah.edu).

